#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAX 60

/* N de ligao */
struct no {
	struct no * prox;
	struct no * ant;
	void * dados;
};
typedef struct no NO;
typedef NO * PNO;
typedef NO ** PPNO;

/* Elemento de dados */
struct aluno {
	int numero;
	char nome[MAX];
};
typedef struct aluno ALUNO;
typedef ALUNO * PALUNO;

/* Cria aluno */
PALUNO criaAluno() {
        PALUNO novo;
        novo = (PALUNO)malloc(sizeof(ALUNO));
        printf("Nmero: ");
        scanf("%d", &novo->numero);
	/* Apaga resto da linha */
        scanf("%*[^\n]"); scanf("%*c");
        printf("Nome: ");
        fflush (stdout);
        fgets(novo->nome, MAX, stdin);
	/* Elimina '\n' no fim da string */
        novo->nome[strlen(novo->nome)-1] = '\0';
        return novo;
}

/* Inserir no incio */
void insereInicio(PPNO cabeca, void * dados) {
	PNO novo;
	novo = (PNO)malloc(sizeof(NO));
	if(*cabeca) (*cabeca)->ant = novo;
	novo->prox = *cabeca;
	novo->ant = NULL;
	*cabeca = novo;
	novo->dados = dados;
}

/* Inserir no fim */
void insereFim(PPNO cabeca, void * dados) {
	PNO ptr, novo;
	if(!*cabeca)
		insereInicio(cabeca, dados);
	else {
		for(ptr=*cabeca; ptr->prox; ptr=ptr->prox);
		novo = (PNO)malloc(sizeof(NO));
		ptr->prox = novo;
		novo->prox = NULL;
		novo->ant = ptr;
		novo->dados = dados;

	}
}

void imprime(PNO cabeca, void (*imprimeDados)()) {
	PNO ptr;
	for(ptr=cabeca; ptr; ptr=ptr->prox) {
		(*imprimeDados)(ptr->dados);
	}
}

void imprimeAluno(PALUNO p) {
	printf("%d - %s\n", p->numero, p->nome);
}

/* Funo genrica de pesquisa */
void* pesquisa(PNO cabeca, int (*compara)(), void* valor) {
	PNO ptr;
	for(ptr=cabeca; ptr; ptr=ptr->prox)
		if((*compara)(ptr->dados, valor))
			return ptr->dados;
	return NULL;
}

/* Funes auxiliares de pesquisa */
int cmpNumAluno(PALUNO a, int* num) {
	return a->numero == *num;
}

int cmpNomeAluno(PALUNO a, char* nome) {
	return strcmp(a->nome, nome) == 0;
}

/* Bubblesort - funes auxiliares */
int nomeCres(PALUNO a, PALUNO b) {
	return strcmp(a->nome, b->nome) > 0;
}

int nomeDecr(PALUNO a, PALUNO b) {
	return strcmp(a->nome, b->nome) < 0;
}

int numCres(PALUNO a, PALUNO b) {
	return a->numero > b->numero;
}

int numDecr(PALUNO a, PALUNO b) {
	return a->numero < b->numero;
}

/* Bubblesort - funo genrica */
void bubblesort (PNO cabeca, int (*compara)()) {
	PNO ptr;
	void * tmp;
	int trocou;
	do {
		trocou = 0;
		for(ptr=cabeca; ptr && ptr->prox; ptr=ptr->prox) {
			if((*compara)(ptr->dados, ptr->prox->dados)) {
				tmp = ptr->dados;
				ptr->dados = ptr->prox->dados;
				ptr->prox->dados = tmp;
				trocou = 1;
			}
		}
	} while(trocou==1);
}

int main() {
	PNO alunos=NULL;
	PALUNO ptr;
	int num;
	char nome[MAX];
	int opcao;
	do {
		printf("\nListas Genricas\n");
		printf("\n1 - Inserir aluno no incio");
		printf("\n2 - Inserir aluno no fim");
		printf("\n3 - Imprimir lista de alunos");
		printf("\n4 - Pesquisar por nmero");
		printf("\n5 - Pesquisar por nome");
		printf("\n6 - Ordenar por nmero, ordem crescente");
		printf("\n7 - Ordenar por nome, ordem crescente");
		printf("\n8 - Ordenar por nmero, ordem decrescente");
		printf("\n9 - Ordenar por nome, ordem decrescente");
		printf("\n0 - Sair");
		printf("\nInsira a opo: ");
		opcao = getchar();
		scanf("%*[^\n]"); scanf("%*c");
		switch(opcao) {
			case '1':
				ptr = criaAluno();
				insereInicio(&alunos,ptr);
				break;
			case '2':
				ptr = criaAluno();
				insereFim(&alunos,ptr);
				break;
			case '3':
				imprime(alunos,imprimeAluno);
				break;
			case '4':
				printf("Numero: ");
			        scanf("%d", &num);
 			        scanf("%*[^\n]"); scanf("%*c");
				ptr = pesquisa(alunos, cmpNumAluno, &num);
				if(ptr) imprimeAluno(ptr);
				else printf("Aluno inexistente");
				break;
			case '5':
				printf("Nome: ");
			        fgets(nome, MAX, stdin);
			        nome[strlen(nome)-1] = '\0';
				ptr = pesquisa(alunos, cmpNomeAluno, nome);
				if(ptr) imprimeAluno(ptr);
				else printf("Aluno inexistente");
				break;
			case '6':
				bubblesort(alunos,numCres);
				break;
			case '7':
				bubblesort(alunos,nomeCres);
				break;
			case '8':
				bubblesort(alunos,numDecr);
				break;
			case '9':
				bubblesort(alunos,nomeDecr);
				break;
		}
	} while(opcao != '0');
}

